IDS="1 2 3 5 4 6 7"

function stop() {
    for id in $IDS ; do
	virsh destroy ceph$id
	virsh undefine ceph$id
	rm -f ceph$id.qcow2
    done
    virsh net-destroy ceph
    virsh net-undefine ceph    
}

function start() {

    if ! test -f debian-10.qcow2 ; then
	sudo virt-builder debian-10 --output debian-10.qcow2 --size 30G --format qcow2 --install sudo --run-command 'dpkg-reconfigure --frontend=noninteractive openssh-server' --run-command 'useradd -s /bin/bash -m debian || true ; echo "debian ALL=(ALL) NOPASSWD:ALL" > /etc/sudoers.d/90-debian'  --ssh-inject debian:file:$HOME/.ssh/id_rsa.pub --edit '/etc/network/interfaces: s/ens2/enp1s0/'
    fi

    if ! virsh net-list --name | grep ceph ; then
	cat > /tmp/ceph-net.xml <<EOF
            <network>
              <name>ceph</name>
              <forward mode='nat'/>
              <bridge name='virbrceph' stp='on' delay='0'/>
              <ip address='10.11.12.1' netmask='255.255.255.0'>
                <dhcp>
                  <range start='10.11.12.100' end='10.11.12.200'/>
		  <host mac='52:54:00:00:00:01' name='ceph1' ip='10.11.12.211'/>
		  <host mac='52:54:00:00:00:02' name='ceph2' ip='10.11.12.212'/>
		  <host mac='52:54:00:00:00:03' name='ceph3' ip='10.11.12.213'/>
		  <host mac='52:54:00:00:00:04' name='ceph4' ip='10.11.12.214'/>
		  <host mac='52:54:00:00:00:05' name='ceph5' ip='10.11.12.215'/>
		  <host mac='52:54:00:00:00:06' name='ceph6' ip='10.11.12.216'/>
		  <host mac='52:54:00:00:00:07' name='ceph7' ip='10.11.12.217'/>
                </dhcp>
              </ip>
            </network>
EOF
	virsh net-define /tmp/ceph-net.xml
	virsh net-start ceph
    fi


    for id in $IDS ; do
	virsh destroy ceph$id
	virsh undefine ceph$id
	rm -f ceph$id.qcow2
	cp --sparse=always debian-10.qcow2 ceph$id.qcow2
	sudo virt-sysprep -a ceph$id.qcow2 --enable customize --hostname ceph$id
	virt-install --network network=ceph,mac=52:54:00:00:00:0$id --boot hd --name ceph$id --memory 2048 --vcpus 1 --cpu host --disk path=$(pwd)/ceph$id.qcow2,bus=virtio,format=qcow2 --os-type=linux --os-variant=debian10 --graphics none --noautoconsole
    done
    sleep 30 # wait for ssh to come up
}

function restart() {
    stop
    start
}

"${@:-restart}"
